UDEVADM(8)

NAME
udevadm - udev management tool

SYNOPSIS

udevadm [--debug] [--version] [--help]

udevadm info options

udevadm trigger [options]

udevadm settle [options]

udevadm control command

udevadm monitor [options]

udevadm test [options] devpath

DESCRIPTION

udevadm expects a command and command specific options. It controls the runtime behavior of udev, requests kernel events, manages the event queue, and provides simple debugging mechanisms.

OPTIONS

--debug
    Print debug messages to stderr.

--version
    Print version number.

--help
    Print help text.

  udevadm info options

Queries the udev database for device information stored in the udev database. It can also query the properties of a device from its sysfs representation to help creating udev rules that match this device.

--query=type
    Query the database for specified type of device data. It needs the --path or --name to identify the specified device. Valid queries are: name, symlink, path, property, all.

--path=devpath
    The devpath of the device to query.

--name=file
    The name of the device node or a symlink to query

--root
    The udev root directory: /dev. If used in conjunction with a name or symlink query, the query returns the absolute path including the root directory.

--attribute-walk
    Print all sysfs properties of the specified device that can be used in udev rules to match the specified device. It prints all devices along the chain, up to the root of sysfs that can be used in udev rules.

--device-id-of-file=file
    Print major/minor numbers of the underlying device, where the file lives on.

--export-db
    Export the content of the udev database.

--version
    Print version.

--help
    Print help text.

  udevadm trigger [options]

Request device events from the kernel. Usually used to replay events at system coldplug time.

--verbose
    Print the list of devices which will be triggered.

--dry-run
    Do not actually trigger the event.

--type=type
    Trigger a specific type of devices. Valid types are: devices, subsystems, failed. The default value is devices.

--action=action
    Type of event to be triggered. The default value is add.

--subsystem-match=subsystem
    Trigger events for devices which belong to a matching subsystem. This option can be specified multiple times and supports shell style pattern matching.

--subsystem-nomatch=subsystem
    Do not trigger events for devices which belong to a matching subsystem. This option can be specified multiple times and supports shell style pattern matching.

--attr-match=attribute=value
    Trigger events for devices with a matching sysfs attribute. If a value is specified along with the attribute name, the content of the attribute is matched against the given value using shell style pattern matching. If no value is specified, the existence of the sysfs attribute is checked. This option can be specified multiple times.

--attr-nomatch=attribute=value
    Do not trigger events for devices with a matching sysfs attribute. If a value is specified along with the attribute name, the content of the attribute is matched against the given value using shell style pattern matching. If no value is specified, the existence of the sysfs attribute is checked. This option can be specified multiple times.

--property-match=property=value
    Trigger events for devices with a matching property value. This option can be specified multiple times and supports shell style pattern matching.

--sysname-match=name
    Trigger events for devices with a matching sys device name. This option can be specified multiple times and supports shell style pattern matching.

  udevadm settle [options]

Watches the udev event queue, and exits if all current events are handled.

--timeout=seconds
    Maximum number of seconds to wait for the event queue to become empty. The default value is 180 seconds. A value of 0 will check if the queue is empty and always return immediately.

--seq-start=seqnum
    Wait only for events after the given sequence number.

--seq-end=seqnum
    Wait only for events before the given sequence number.

--exit-if-exists=file
    Stop waiting if file exists.

--quiet
    Do not print any output, like the remaining queue entries when reaching the timeout.

--help
    Print help text.

  udevadm control command

Modify the internal state of the running udev daemon.

--log-priority=value
    Set the internal log level of udevd. Valid values are the numerical syslog priorities or their textual representations: err, info and debug.

--stop-exec-queue
    Signal udevd to stop executing new events. Incoming events will be queued.

--start-exec-queue
    Signal udevd to enable the execution of events.

--reload-rules
    Signal udevd to reload the rules files. The udev daemon detects changes automatically, this option is usually not needed. Reloading rules does not apply any changes to already existing devices.

--property=KEY=value
    Set a global property for all events.

--max-childs=value
    Set the maximum number of events, udevd will handle at the same time.

--help
    Print help text.

  udevadm monitor [options]

Listens to the kernel uevents and events sent out by a udev rule and prints the devpath of the event to the console. It can be used to analyze the event timing, by comparing the timestamps of the kernel uevent and the udev event.

--kernel
    Print the kernel uevents.

--udev
    Print the udev event after the rule processing.

--property
    Also print the properties of the event.

--help
    Print help text.

  udevadm test [options] devpath

Simulate a udev event run for the given device, and print debug output.

--action=string
    The action string.

--subsystem=string
    The subsystem string.

--help
    Print help text.

AUTHOR

Written by Kay Sievers kay.sievers@vrfy.org.

SEE ALSO

udev(7) udevd(8)